package cz.jzitnik.game.sprites.ui;

import cz.jzitnik.tui.Sprite;
import lombok.extern.slf4j.Slf4j;

import java.util.HashMap;
import java.util.Optional;

@Slf4j
public class Number extends Sprite<Number.NumberState> {
    public enum NumberState {
        ZERO, ONE, TWO, THREE, FOUR, FIVE, SIX, SEVEN, EIGHT, NINE,
    }

    public Number() {
        loadResources(new HashMap<>() {
            {
                put(NumberState.ZERO, "numbers/0.ans");
                put(NumberState.ONE, "numbers/1.ans");
                put(NumberState.TWO, "numbers/2.ans");
                put(NumberState.THREE, "numbers/3.ans");
                put(NumberState.FOUR, "numbers/4.ans");
                put(NumberState.FIVE, "numbers/5.ans");
                put(NumberState.SIX, "numbers/6.ans");
                put(NumberState.SEVEN, "numbers/7.ans");
                put(NumberState.EIGHT, "numbers/8.ans");
                put(NumberState.NINE, "numbers/9.ans");
            }
        }, NumberState.class);
    }

    public static String fixForHotbar(String str, int place) {
        var parts = str.split("\n");
        // Make it 50x25
        StringBuilder stringBuilder = new StringBuilder();
        for (int i = 0; i < 24 - 12; i++) {
            stringBuilder.append("\033[0m ".repeat(50)).append("\n");
        }
        for (int i = 0; i < 12; i++) {
            stringBuilder.append("\033[0m ".repeat(50 - 12 * place)).append(parts[i])
                    .append("\033[0m ".repeat(12 * (place - 1))).append("\n");
        }
        stringBuilder.append("\033[0m ".repeat(50)).append("\n");

        return stringBuilder.toString();
    }

    private String fix(String x) {
        return x;
        // return x.replaceAll("\033\\[38;5;1;48;5;16m", "\033[0m").replaceAll("\033\\[38;5;16;48;5;16m▓", "\033[0m ");
        // TODO: Fix issue with sprite size decreasing
    }

    public String getSprite() {
        return getSprite(NumberState.ZERO);
    }

    public String getSprite(NumberState key) {
        log.debug("{}", key);
        return fix(getResource(key));
    }

    @Override
    public Optional<Class<NumberState>> getStates() {
        return Optional.of(NumberState.class);
    }
}
